	org $1001-2
	dw  $1001
	
	include "!playerv.asm"
	
	dw nextln,0	; second word is line number
	db $9E,"4109",0
nextln	db 0,0

txt_ptr	= $C0
ltr_ptr	= $C2
anm_ptr	= $C4
clr_ptr	= $D0
rev_ptr	= $D0
ptr	= $D2

buffer = $0FE8
	
start
	sei
	sta $ff3f
	;
	jsr PLAYER_INIT
	;
	lda #irq & 255
	sta $FFFE
	lda #irq >> 8
	sta $FFFF
	lda #$9C
	sta $FF0B
	;
	lda #text_data & 255
	sta txt_ptr
	lda #text_data >> 8
	sta txt_ptr+1
	;
	lda #letter_space & 255
	sta ltr_ptr
	lda #letter_space >> 8
	sta ltr_ptr+1
	;
	lda #anim_data & 255
	sta anm_ptr
	lda #anim_data >> 8
	sta anm_ptr+1
	;
	cli
	;jmp anim_done
	;
	lda #(clear_data-2) & 255
	sta clr_ptr
	lda #(clear_data-2) >> 8
	sta clr_ptr+1
	;
clr_1	lda clr_ptr+1
	cmp #(clear_data_end-2) >> 8
	bne clr_2
	lda clr_ptr
	cmp #(clear_data_end-2) & 255
	beq clr_done
	;
clr_2	ldx #$CC
	cpx $FF1D
	bne *-3
	;
clr_3	lda clr_ptr
	clc
	adc #$02
	sta clr_ptr
	bcc *+4
	inc clr_ptr+1
	;
	ldy #$00
	lda (clr_ptr),y
	sta ptr
	iny
	lda (clr_ptr),y
	tax
	and #$0F
	sta ptr+1
	;
	dey
	lda #$A0
	sta (ptr),y
	;
	txa
	and #$0B
	sta ptr+1
	lda $FF19
	and #$7F
	sta (ptr),y
	;
	txa
	bmi clr_1
	bpl clr_3
	;
clr_done
	;
	; -----------------------------
	;
	lda $FF06
	and #$EF
	sta $FF06
	;
	lda $FF07
	and #$40
	beq pal_1
	;
	; NTSC modifications
	;
	lda #$F6
	sta blk_0+1
	lda #$02
	sta blk_1+1
	lda #$24
	sta blk_7
	lda #$65
	sta blk_2+1
	;
pal_1	ldy $FF19
	;
blk_0	lda #$00
	cmp $FF1D
	bne *-3
	lda $FF1C
	cmp #$FE
blk_7	beq blk_0
	;
	sty $FF19
	;
	lda #$FE
	cmp $FF1C
blk_3	bne *-3
	;
blk_1	ldx #$00
	lda sine,x
	tax
	cpx $FF1D
	bne *-3
	;
	asl $02
	asl $02
	asl $02
	asl $02
	asl $02
	asl $02
	asl $02
	asl $02
	asl $02
	asl $02
	asl $02
	asl $02
	asl $02
	asl $02
	asl $02
	asl $02
	asl $02
	asl $02
	nop
	;
	lda #$00
	sta $FF19
	;
	inc blk_1+1
	lda blk_1+1
	cmp #$08
	bne blk_2
	;
	lda #$CC
	sta $FF0B
	;
blk_2	cmp #$6E
	beq blk_done
	;
	cmp #$65
	bne blk_6
	;
	lda #$24
	sta blk_3
	;
blk_6	jmp blk_0
	;
blk_done
	;
	; -----------------------------
	;
	ldx #$03
	ldy #$00
	sty ptr
	lda #$08
	sta ptr+1
	tya
blk_5	sta (ptr),y			; clear screen
	iny
	bne *-3
	inc ptr+1
	dex
	bpl blk_5
	;
	lda #$32
	sta $FF15
	;
	lda #$1B
	sta $FF06
	;
	lda #$BC
	sta $FF0B
	;
	lda #(reveal_data-2) & 255
	sta rev_ptr
	lda #(reveal_data-2) >> 8
	sta rev_ptr+1
	;
rev_1	lda rev_ptr+1
	cmp #(reveal_data_end-2) >> 8
	bne rev_2
	lda rev_ptr
	cmp #(reveal_data_end-2) & 255
	beq reveal_done
	;
rev_2	ldx #$CC
	cpx $FF1D
	bne *-3
	;
rev_3	lda rev_ptr
	clc
	adc #$02
	sta rev_ptr
	bcc *+4
	inc rev_ptr+1
	;
	ldy #$00
	lda (rev_ptr),y
	sta ptr
	sta ptr+2
	sta ptr+4
	sta ptr+6
	iny
	lda (rev_ptr),y
	tax
	and #$0F
	sta ptr+1
	and #$0B
	sta ptr+5
	clc
	adc #(santa >> 8)-4
	sta ptr+3
	sec
	sbc #$04
	sta ptr+7
	;
	dey
	lda (ptr+2),y
	sta (ptr),y
	lda (ptr+6),y
	sta (ptr+4),y
	;
	txa
	bmi rev_1
	bpl rev_3
	;
reveal_done
	;
	; -------------------------
	;
	ldy #$00			; Y will remain 0 for entire anim
anim_sync
	lda #$CC
	cmp $FF1D
	bne *-3
	;
anm_1	jsr get_anim_byte
	tax
	beq anim_done			; $00 = end of animation,
	bmi anim_delay			; $FF = delay, ...
	;
	;dec $FF19
	jsr get_anim_byte		; ...otherwise it's number of bytes to copy
	sta ptr				; get address first (2 bytes)
	sta ptr+2
	jsr get_anim_byte
	sta ptr+1
	and #$0B
	sta ptr+3
	;
anm_3	jsr get_anim_byte		; get char and color
	sta (ptr),y
	jsr get_anim_byte
	sta (ptr+2),y
	;
	inc ptr
	inc ptr+2
	;
	dex
	bne anm_3
	;
	;inc $FF19
	jmp anm_1
	;
anim_delay
	jsr get_anim_byte
	tax
	lda #$CC
anm_2	cmp $FF1D
	bne *-3
	cmp $FF1D
	beq *-3
	dex
	bne anm_2
	;
	jmp anm_1
	;
	; -------------------------
	;
anim_done
	lda #(clear2_data-2) & 255
	sta clr_ptr
	lda #(clear2_data-2) >> 8
	sta clr_ptr+1
	;
clr2_1	lda clr_ptr+1
	cmp #(clear2_data_end-2) >> 8
	bne clr2_2
	lda clr_ptr
	cmp #(clear2_data_end-2) & 255
	beq clr2_done
	;
clr2_2	ldx #$CC
	cpx $FF1D
	bne *-3
	;
clr2_3	lda clr_ptr
	clc
	adc #$02
	sta clr_ptr
	bcc *+4
	inc clr_ptr+1
	;
	ldy #$00
	lda (clr_ptr),y
	sta ptr
	iny
	lda (clr_ptr),y
	tax
	and #$0F
	sta ptr+1
	;
	dey
	lda #$A0
	sta (ptr),y
	;
	txa
	and #$0B
	sta ptr+1
	lda #$00
	sta (ptr),y
	;
	txa
	bmi clr2_1
	bpl clr2_3
	;
clr2_done
	;
	; ---
	;
	lda #$00
	sta $FF15
	;
	ldx #$03
	ldy #$00
	sty ptr
	sty ptr+2
	lda #$08
	sta ptr+1
	lda #tree >> 8
	sta ptr+3
	tya
cls_1	sta (ptr),y			; clear screen
	iny
	bne cls_1
	inc ptr+1
	dex
	bpl cls_1
	;
	ldx #$03
cls_2	lda (ptr+2),y
	sta (ptr),y
	iny
	bne cls_2
	inc ptr+1
	inc ptr+3
	dex
	bpl cls_2
	;
	lda #irq2 & 255
	sta $FFFE
	lda #irq2 >> 8
	sta $FFFF
	lda #$02
	sta $FF0B
	;
	; ---
	;
kloop	lda #$7F
	sta $FD30
	sta $FF08
	lda $FF08
	and #$80	; Query keyboard for "Run/Stop"
	bne kloop
	;
	sei
	sta $FF3E
	;
	lda #$00
	sta $FF11
	lda #$71
	sta $FF15
	lda #$EE
	sta $FF19
	cli
	;
	lda #$13	; "home"
	jsr $FFD2
	lda #$11	; "down"
	jsr $FFD2
	lda #$11	; "down"
	jsr $FFD2
	lda #$11	; "down"
	jsr $FFD2
	lda #$11	; "down"
	jsr $FFD2
	jmp $8003
	
scroll1 macro addr
	lda addr+1
	sta addr
	endm

scroll4 macro addr
	scroll1 addr
	scroll1 addr+1
	scroll1 addr+2
	scroll1 addr+3
	endm
		
scroll16 macro addr
	scroll4 addr
	scroll4 addr+4
	scroll4 addr+8
	scroll4 addr+12
	endm
	
scroll
	scroll16 $0C00		; line 1
	scroll1 $0C00+16
	lda buffer+1
	sta $0C00+17
	lda $0C00+19
	sta buffer+1
	scroll1 $0C00+19
	scroll16 $0C00+20
	scroll1 $0C00+36
	scroll1 $0C00+37
	scroll1 $0C00+38
	;
	scroll16 $0C28		; line 2
	scroll1 $0C28+16
	lda buffer+2
	sta $0C28+17
	lda buffer+3
	sta buffer+2
	lda $0C28+20
	sta buffer+3
	scroll16 $0C28+20
	scroll1 $0C28+36
	scroll1 $0C28+37
	scroll1 $0C28+38
	;
	scroll16 $0C50		; line 3
	lda buffer+4
	sta $0C50+16
	lda buffer+5
	sta buffer+4
	lda buffer+6
	sta buffer+5
	lda buffer+7
	sta buffer+6
	lda $0C50+21
	sta buffer+7
	scroll16 $0C50+21
	scroll1 $0C50+37
	scroll1 $0C50+38
	;
	scroll16 $0C78		; line 4
	lda buffer+8
	sta $0C78+16
	lda buffer+9
	sta buffer+8
	lda buffer+10
	sta buffer+9
	lda buffer+11
	sta buffer+10
	lda $0C78+21
	sta buffer+11
	scroll16 $0C78+21
	scroll1 $0C78+37
	scroll1 $0C78+38
	;
	scroll4 $0CA0		; line 5
	scroll4 $0CA0+4
	scroll4 $0CA0+8
	scroll1 $0CA0+12
	scroll1 $0CA0+13
	scroll1 $0CA0+14
	lda buffer+12
	sta $0CA0+15
	lda buffer+13
	sta buffer+12
	lda buffer+14
	sta buffer+13
	lda buffer+15
	sta buffer+14
	lda buffer+16
	sta buffer+15
	lda buffer+17
	sta buffer+16
	lda $0CA0+22
	sta buffer+17
	scroll16 $0CA0+22
	scroll1 $0CA0+38
	;
	ldy #$00
scr_2	lda (ltr_ptr),y
	cmp #$FF
	bne scr_1
	;
scr_4	lda (txt_ptr),y
	bpl scr_3
	;
	lda #text_data & 255
	sta txt_ptr
	lda #text_data >> 8
	sta txt_ptr+1
	jmp scr_4
	;
scr_3	asl a
	tax
	lda letter_data,x
	sta ltr_ptr
	lda letter_data+1,x
	sta ltr_ptr+1
	;
	lda txt_ptr
	clc
	adc #$01
	sta txt_ptr
	bcc *+4
	inc txt_ptr+1
	;
	jmp scr_2
	;
scr_1	sta $0C27
	iny
	lda (ltr_ptr),y
	sta $0C27+40
	iny
	lda (ltr_ptr),y
	sta $0C27+80
	iny
	lda (ltr_ptr),y
	sta $0C27+120
	iny
	lda (ltr_ptr),y
	sta $0C27+160
	;
	lda ltr_ptr
	clc
	adc #$05
	sta ltr_ptr
	bcc *+4
	inc ltr_ptr+1
	;
	rts
	
animate_candles
	ldx #$00
	inx
	stx animate_candles+1
	txa
	lsr a
	and #$0F
	tax
	lda candle_animation,x
	sta $0D07
	lda candle_animation+1,x
	sta $0E13
	lda candle_animation+2,x
	sta $0F17
	rts
	
get_anim_byte
	lda (anm_ptr),y
	inc anm_ptr
	bne *+4
	inc anm_ptr+1
	rts

	align 256	
irq	pha
	txa
	pha
	tya
	pha
	;
	asl $FF09
	;
	;dec $FF19
	jsr PLAYER
	;inc $FF19
	;
	pla
	tay
	pla
	tax
	pla
	rti

irq2
	pha
	txa
	pha
	tya
	pha
	;
	asl $FF09
	;
	asl $02
	asl $02
	asl $02
	asl $02
	asl $02
	asl $02
	asl $02
	bit $02
	;
	ldy #$A8
	ldx #56
l1	lda final_colors,x
	cpy $FF1E
	bcs *-3
	sta $FF19
	sta $FF15
	inx
	bne l1
	;
	nop
	nop
	nop
	cpy $FF1E
	bcs *-3
	lda #$00
	sta $FF19
	;
	;inc $FF19
	jsr PLAYER
	;dec $FF19
	;
	;dec $FF19
	jsr scroll
	;inc $FF19
	;
	jsr animate_candles
	;
	;dec $FF19
	;
ptr2	ldx #$00
	lda color_sine,x
	sta ptr1+1
	inc ptr2+1
	;
ptr3	ldx #56
	lda cols1,x
	sta cols,x
	inc ptr3+1
	;
	ldx #56
l2
ptr1	lda lums,x
	ora cols,x
	sta final_colors,x
	inx
	bne l2
	;
	
	;
	;inc $FF19
	;
	pla
	tay
	pla
	tax
	pla
	rti

	align $800
santa
	include "santa.asm"
	
	align 256
tree
	include "tree.asm"
	
anim_data
	; blink
	db 1, $30,$0D, $EF,$52
	db $FF, 5
	db 1, $30,$0D, $E0,$52, 1, $58,$0D, $EF,$52
	db $FF, 5
	db 1, $30,$0D, $EF,$52, 1, $58,$0D, $FC,$71
	db $FF, 5
	db 1, $30,$0D, $EC,$71
	db $FF, 30
	;
	; mouth
	db 1, $1E,$0E, $8A,$10, 1, $46,$0E, $EF,$10, $FF, 4
	db 1, $1E,$0E, $F2,$10, 1, $46,$0E, $E0,$10, $FF, 4
	db 1, $1E,$0E, $8A,$10, 1, $46,$0E, $EF,$10, $FF, 4
	db 1, $1E,$0E, $94,$10, 1, $46,$0E, $E2,$10, $FF, 70
	;
	; blink
	db 1, $30,$0D, $EF,$52
	db $FF, 4
	db 1, $30,$0D, $E0,$52, 1, $58,$0D, $EF,$52
	db $FF, 4
	db 1, $30,$0D, $EF,$52, 1, $58,$0D, $FC,$71
	db $FF, 4
	db 1, $30,$0D, $EC,$71
	db $FF, 70
	;
	; ho-ho-ho!
	db  7, $F9,$0E, $E9,$71,$F7,$71,$F7,$71,$F7,$71,$F7,$71,$F7,$71,$F7,$71
	db  4, $00,$0F, $F7,$71,$DF,$71,$EC,$70,$E9,$71
	db 11, $21,$0F, $F4,$71,$C2,$71,$E0,$71,$C2,$71,$D5,$71,$C3,$71,$C9,$71,$E0,$71,$E0,$71,$62,$71,$69,$71
	db 10, $49,$0F, $F4,$71,$EB,$71,$C0,$71,$F3,$71,$C2,$71,$E0,$71,$C2,$71,$C0,$71,$E0,$71,$69,$71
	db  9, $71,$0F, $F4,$71,$C2,$71,$E0,$71,$C2,$71,$CA,$71,$C3,$71,$CB,$71,$E0,$71,$EA,$71
	db  9, $99,$0F, $5F,$71,$EF,$71,$EF,$71,$EF,$71,$EF,$71,$EF,$71,$EF,$71,$EF,$71,$69,$71
	db $FF, 2
	;
	db 1, $1E,$0E, $8A,$10, 1, $46,$0E, $EF,$10, $FF, 3
	db 1, $1E,$0E, $F2,$10, 1, $46,$0E, $E0,$10, $FF, 3
	db 1, $1E,$0E, $8A,$10, 1, $46,$0E, $EF,$10, $FF, 3
	db 1, $1E,$0E, $94,$10, 1, $46,$0E, $E2,$10, $FF, 20
	;
	db  7, $F9,$0E, $E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10
	db  4, $00,$0F, $E0,$10,$E0,$10,$E0,$10,$E0,$10
	db 11, $21,$0F, $E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10
	db 10, $49,$0F, $E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10
	db  9, $71,$0F, $E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10
	db  9, $99,$0F, $E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10
	db $FF, 15
	;
	db  7, $F9,$0E, $E9,$71,$F7,$71,$F7,$71,$F7,$71,$F7,$71,$F7,$71,$F7,$71
	db  4, $00,$0F, $F7,$71,$DF,$71,$EC,$70,$E9,$71
	db 11, $21,$0F, $F4,$71,$C2,$71,$E0,$71,$C2,$71,$D5,$71,$C3,$71,$C9,$71,$E0,$71,$E0,$71,$62,$71,$69,$71
	db 10, $49,$0F, $F4,$71,$EB,$71,$C0,$71,$F3,$71,$C2,$71,$E0,$71,$C2,$71,$C0,$71,$E0,$71,$69,$71
	db  9, $71,$0F, $F4,$71,$C2,$71,$E0,$71,$C2,$71,$CA,$71,$C3,$71,$CB,$71,$E0,$71,$EA,$71
	db  9, $99,$0F, $5F,$71,$EF,$71,$EF,$71,$EF,$71,$EF,$71,$EF,$71,$EF,$71,$EF,$71,$69,$71
	db $FF, 2
	;
	db 1, $1E,$0E, $8A,$10, 1, $46,$0E, $EF,$10, $FF, 3
	db 1, $1E,$0E, $F2,$10, 1, $46,$0E, $E0,$10, $FF, 3
	db 1, $1E,$0E, $8A,$10, 1, $46,$0E, $EF,$10, $FF, 3
	db 1, $1E,$0E, $94,$10, 1, $46,$0E, $E2,$10, $FF, 20
	;
	db  7, $F9,$0E, $E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10
	db  4, $00,$0F, $E0,$10,$E0,$10,$E0,$10,$E0,$10
	db 11, $21,$0F, $E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10
	db 10, $49,$0F, $E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10
	db  9, $71,$0F, $E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10
	db  9, $99,$0F, $E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10
	db $FF, 15
	;
	db  7, $F9,$0E, $E9,$71,$F7,$71,$F7,$71,$F7,$71,$F7,$71,$F7,$71,$F7,$71
	db  4, $00,$0F, $F7,$71,$DF,$71,$EC,$70,$E9,$71
	db 11, $21,$0F, $F4,$71,$C2,$71,$E0,$71,$C2,$71,$D5,$71,$C3,$71,$C9,$71,$C2,$71,$E0,$71,$62,$71,$69,$71
	db 10, $49,$0F, $F4,$71,$EB,$71,$C0,$71,$F3,$71,$C2,$71,$E0,$71,$C2,$71,$C2,$71,$E0,$71,$69,$71
	db  9, $71,$0F, $F4,$71,$C2,$71,$E0,$71,$C2,$71,$CA,$71,$C3,$71,$CB,$71,$AE,$71,$EA,$71
	db  9, $99,$0F, $5F,$71,$EF,$71,$EF,$71,$EF,$71,$EF,$71,$EF,$71,$EF,$71,$EF,$71,$69,$71
	db $FF, 2
	;
	db 1, $1E,$0E, $8A,$10, 1, $46,$0E, $EF,$10, $FF, 3
	db 1, $1E,$0E, $F2,$10, 1, $46,$0E, $E0,$10, $FF, 3
	db 1, $1E,$0E, $8A,$10, 1, $46,$0E, $EF,$10, $FF, 3
	db 1, $1E,$0E, $94,$10, 1, $46,$0E, $E2,$10, $FF, 60
	;
	db  7, $F9,$0E, $E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10
	db  4, $00,$0F, $E0,$10,$E0,$10,$E0,$10,$E0,$10
	db 11, $21,$0F, $E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10
	db 10, $49,$0F, $E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10
	db  9, $71,$0F, $E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10
	db  9, $99,$0F, $E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10,$E0,$10
	db $FF, 40
	;
	; blink
	db 1, $30,$0D, $EF,$52
	db $FF, 5
	db 1, $30,$0D, $E0,$52, 1, $58,$0D, $EF,$52
	db $FF, 5
	db 1, $30,$0D, $EF,$52, 1, $58,$0D, $FC,$71
	db $FF, 5
	db 1, $30,$0D, $EC,$71
	db $FF, 70
	;
	db 0
	
candle_animation
	db $2A,$23,$41,$1C
	db $23,$2A,$41,$1C
	db $41,$23,$1C,$2A
	db $1C,$41,$2A,$23
	
	align 256
final_colors
	ds 256
	
	align 256
cols
	ds 256
	
	align 256
cols1
	db 0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0
	db 0,0,0,0,0,0,0,0
	;
	db $2,$2,$2,$2,$2,$2,$2,$2,$2,$2,$2,$2
	;
	db $2,$2,$2,$2,$2,$2,$2,$2
	db $8,$2,$2,$8,$2,$2
	db $8,$2,$8,$2,$8,$2,$8,$2
	db $8,$8,$2,$8,$8,$2
	db $8,$8,$8,$8,$8,$8,$8,$8
	db $9,$8,$8,$9,$8,$8
	db $9,$8,$9,$8,$9,$8,$9,$8
	db $9,$9,$8,$9,$9,$8
	db $9,$9,$9,$9,$9,$9,$9,$9
	db $7,$9,$9,$7,$9,$9
	db $7,$9,$7,$9,$7,$9,$7,$9
	db $7,$7,$9,$7,$7,$9
	db $7,$7,$7,$7,$7,$7,$7,$7
	db $A,$7,$7,$A,$7,$7
	db $A,$7,$A,$7,$A,$7,$A,$7
	db $A,$A,$7,$A,$A,$7
	db $A,$A,$A,$A,$A,$A,$A,$A
	db $F,$A,$A,$F,$A,$A
	db $F,$A,$F,$A,$F,$A,$F,$A
	db $F,$F,$A,$F,$F,$A
	db $F,$F,$F,$F,$F,$F,$F,$F
	db $5,$F,$F,$5,$F,$F
	db $5,$F,$5,$F,$5,$F,$5,$F
	db $5,$5,$F,$5,$5,$F
	db $5,$5,$5,$5,$5,$5,$5,$5
	;
	db $5,$5,$5,$5,$5,$5,$5,$5,$5,$5,$5,$5
	
	;db $B,$B,$2,$B,$2,$2,$8,$2,$8,$8,$9,$8,$9,$9,$7,$9,$7,$7,$A,$7,$A,$A,$F,$A,$F,$F,$5,$F,$5,$5,$C,$5,$C,$C,$3,$C,$3,$3,$D,$3,$D,$D,$6,$D,$6,$6,$E,$6,$E,$E,$4,$E,$4,$4,$B,$4
	;db $B,$2,$8,$9,$7,$A,$F,$5,$C,$3,$D,$6,$E,$4
	
	align 256
lums	; repeats: 8+8+32+32 = 80
	db $30,$40,$50,$60,$70,$60,$50,$40
	db $30,$40,$50,$60,$70,$60,$50,$40
	db $30,$40,$30,$40,$40,$50,$40,$50,$50,$60,$50,$60,$60,$70,$60,$70,$70,$60,$70,$60,$60,$50,$60,$50,$50,$40,$50,$40,$40,$30,$40,$30
	db $30,$40,$30,$40,$40,$50,$40,$50,$50,$60,$50,$60,$60,$70,$60,$70,$70,$60,$70,$60,$60,$50,$60,$50,$50,$40,$50,$40,$40,$30,$40,$30
	;
	db $30,$40,$50,$60,$70,$60,$50,$40
	db $30,$40,$50,$60,$70,$60,$50,$40
	db $30,$40,$30,$40,$40,$50,$40,$50,$50,$60,$50,$60,$60,$70,$60,$70,$70,$60,$70,$60,$60,$50,$60,$50,$50,$40,$50,$40,$40,$30,$40,$30
	db $30,$40,$30,$40,$40,$50,$40,$50,$50,$60,$50,$60,$60,$70,$60,$70,$70,$60,$70,$60,$60,$50,$60,$50,$50,$40,$50,$40,$40,$30,$40,$30
	;
	db $30,$40,$50,$60,$70,$60,$50,$40
	db $30,$40,$50,$60,$70,$60,$50,$40
	db $30,$40,$30,$40,$40,$50,$40,$50,$50,$60,$50,$60,$60,$70,$60,$70,$70,$60,$70,$60,$60,$50,$60,$50,$50,$40,$50,$40,$40,$30,$40,$30
	db $30,$40,$30,$40,$40,$50,$40,$50,$50,$60,$50,$60,$60,$70,$60,$70,$70,$60,$70,$60,$60,$50,$60,$50,$50,$40,$50,$40,$40,$30,$40,$30
	;
	db $30,$40,$50,$60,$70,$60,$50,$40
	db $30,$40,$50,$60,$70,$60,$50,$40
	db $30,$40,$30,$40,$40,$50,$40,$50,$50,$60,$50,$60,$60,$70,$60,$70,$70,$60,$70,$60,$60,$50,$60,$50,$50,$40,$50,$40,$40,$30,$40,$30
	db $30,$40,$30,$40,$40,$50,$40,$50,$50,$60,$50,$60,$60,$70,$60,$70,$70,$60,$70,$60,$60,$50,$60,$50,$50,$40,$50,$40,$40,$30,$40,$30
	;
	db $30,$40,$50,$60,$70,$60,$50,$40
	db $30,$40,$50,$60,$70,$60,$50,$40
	db $30,$40,$30,$40,$40,$50,$40,$50,$50,$60,$50,$60,$60,$70,$60,$70,$70,$60,$70,$60,$60,$50,$60,$50,$50,$40,$50,$40,$40,$30,$40,$30
	db $30,$40,$30,$40,$40,$50,$40,$50,$50,$60,$50,$60,$60,$70,$60,$70,$70,$60,$70,$60,$60,$50,$60,$50,$50,$40,$50,$40,$40,$30,$40,$30
	
	align 256
color_sine
	include "color_sine_hex.asm"

	align 256	
sine
	db $FD,$F7,$F0,$E9,$E2,$DB,$D3,$CC,$C4,$BD,$B5,$AE,$A6,$9F,$98
	db $90,$8A,$83,$7D,$76,$71,$6B,$66,$61,$5D,$59,$55,$52,$4F,$4D,$4B
	db $4A,$49,$48,$48,$49,$4A,$4B,$4C,$4E,$51,$53,$56,$59,$5D,$60,$64
	db $68,$6D,$71,$75,$7A,$7E,$82,$87,$8B,$8F,$93,$96,$9A,$9D,$A0,$A3
	db $A5,$A7,$A8,$AA,$AA,$AB,$AB,$AA,$A9,$A8,$A6,$A4,$A1,$9E,$9A,$96
	db $92,$8D,$88,$83,$7D,$77,$70,$6A,$63,$5C,$54,$4D,$46,$3E,$36,$2F
	db $27,$20,$18,$11,$0A,$03
	db $35,$2E,$28,$22,$1D,$18,$13,$0E,$0A,$07,$04,$01
	
	cmap " ",0
	cmap "A",1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26
	cmap "!",27
	cmap "+",28
	cmap "4",29
text_data
	db "                    "
	db "                    "
	db "                    "
	db "                    "
	db "                    "
	db "                    "
	db "                    "
	db "                    "
	db "                    "
	db "                "
	db "MERRY CHRISTMAS! "
	db "                    "
	db "                    "
	db "CSABO AND MMS SEND YOU THEIR VERY BEST WISHES FOR THE HOLIDAY SEASON! "
	db "                    "
	db "                    "
	db "GREETINGS TO ALL THE +4 GUYS! "
	db "                    "
	db "                    "
	db $FF
	cmap
	
letter_data
	dw letter_space
	dw letter_a
	dw letter_b
	dw letter_c
	dw letter_d
	dw letter_e
	dw letter_f
	dw letter_g
	dw letter_h
	dw letter_i
	dw letter_j
	dw letter_k
	dw letter_l
	dw letter_m
	dw letter_n
	dw letter_o
	dw letter_p
	dw letter_q
	dw letter_r
	dw letter_s
	dw letter_t
	dw letter_u
	dw letter_v
	dw letter_w
	dw letter_x
	dw letter_y
	dw letter_z
	dw letter_excl
	dw letter_plus
	dw letter_4

i = $20
Z = $51;CF
letter_space
	db i,i,i,i,i
	db i,i,i,i,i
	db $FF
letter_a
	db Z,Z,Z,Z,Z
	db Z,i,Z,i,i
	db Z,Z,Z,Z,Z
	db i,i,i,i,i
	db $FF
	
letter_b
	db Z,Z,Z,Z,Z
	db Z,i,Z,i,Z
	db i,Z,i,Z,i
	db i,i,i,i,i
	db $FF
	
letter_c
	db Z,Z,Z,Z,Z
	db Z,i,i,i,Z
	db Z,i,i,i,Z
	db i,i,i,i,i
	db $FF
	
letter_d
	db Z,Z,Z,Z,Z
	db Z,i,i,i,Z
	db i,Z,Z,Z,i
	db i,i,i,i,i
	db $FF
	
letter_e
	db Z,Z,Z,Z,Z
	db Z,i,Z,i,Z
	db Z,i,Z,i,Z
	db i,i,i,i,i
	db $FF
	
letter_f
	db Z,Z,Z,Z,Z
	db Z,i,Z,i,i
	db Z,i,Z,i,i
	db i,i,i,i,i
	db $FF
	
letter_g
	db Z,Z,Z,Z,Z
	db Z,i,i,i,Z
	db Z,i,Z,Z,Z
	db i,i,i,i,i
	db $FF
	
letter_h
	db Z,Z,Z,Z,Z
	db i,i,Z,i,i
	db Z,Z,Z,Z,Z
	db i,i,i,i,i
	db $FF
	
letter_i
	db Z,Z,Z,Z,Z
	db i,i,i,i,i
	db $FF
	
letter_j
	db i,i,i,i,Z
	db i,i,i,i,Z
	db Z,Z,Z,Z,Z
	db i,i,i,i,i
	db $FF
	
letter_k
	db Z,Z,Z,Z,Z
	db i,i,Z,i,i
	db Z,Z,i,Z,Z
	db i,i,i,i,i
	db $FF
	
letter_l
	db Z,Z,Z,Z,Z
	db i,i,i,i,Z
	db i,i,i,i,Z
	db i,i,i,i,i
	db $FF
	
letter_m
	db Z,Z,Z,Z,Z
	db Z,i,i,i,i
	db Z,Z,Z,Z,Z
	db Z,i,i,i,i
	db Z,Z,Z,Z,Z
	db i,i,i,i,i
	db $FF
	
letter_n
	db Z,Z,Z,Z,Z
	db Z,i,i,i,i
	db Z,Z,Z,Z,Z
	db i,i,i,i,i
	db $FF
	
letter_o
	db Z,Z,Z,Z,Z
	db Z,i,i,i,Z
	db Z,Z,Z,Z,Z
	db i,i,i,i,i
	db $FF
	
letter_p
	db Z,Z,Z,Z,Z
	db Z,i,Z,i,i
	db Z,Z,Z,i,i
	db i,i,i,i,i
	db $FF
	
letter_q
	db Z,Z,Z,Z,i
	db Z,i,i,Z,i
	db Z,Z,Z,Z,Z
	db i,i,i,i,i
	db $FF
	
letter_r
	db Z,Z,Z,Z,Z
	db Z,i,Z,i,i
	db i,Z,i,Z,Z
	db i,i,i,i,i
	db $FF
	
letter_s
	db Z,Z,Z,i,Z
	db Z,i,Z,i,Z
	db Z,i,Z,Z,Z
	db i,i,i,i,i
	db $FF
	
letter_t
	db Z,i,i,i,i
	db Z,Z,Z,Z,Z
	db Z,i,i,i,i
	db i,i,i,i,i
	db $FF
	
letter_u
	db Z,Z,Z,Z,Z
	db i,i,i,i,Z
	db Z,Z,Z,Z,Z
	db i,i,i,i,i
	db $FF
	
letter_v
	db Z,Z,Z,Z,i
	db i,i,i,i,Z
	db Z,Z,Z,Z,i
	db i,i,i,i,i
	db $FF
	
letter_w
	db Z,Z,Z,Z,Z
	db i,i,i,i,Z
	db Z,Z,Z,Z,Z
	db i,i,i,i,Z
	db Z,Z,Z,Z,Z
	db i,i,i,i,i
	db $FF
	
letter_x
	db Z,Z,i,Z,Z
	db i,i,Z,i,i
	db Z,Z,i,Z,Z
	db i,i,i,i,i
	db $FF
	
letter_y
	db Z,Z,Z,i,i
	db i,i,Z,Z,Z
	db Z,Z,Z,i,i
	db i,i,i,i,i
	db $FF
	
letter_z
	db Z,i,i,Z,Z
	db Z,i,Z,i,Z
	db Z,Z,i,i,Z
	db i,i,i,i,i
	db $FF
	
letter_excl
	db Z,Z,Z,i,Z
	db i,i,i,i,i
	db $FF
	
letter_plus
	db i,i,Z,i,i
	db i,Z,Z,Z,i
	db i,i,Z,i,i
	db i,i,i,i,i
	db $FF
	
letter_4
	db Z,Z,Z,i,i
	db i,i,Z,i,i
	db Z,Z,Z,Z,Z
	db i,i,i,i,i
	db $FF

clear_data
	include "clear_data.asm"
clear_data_end

reveal_data
	include "reveal.asm"
reveal_data_end

clear2_data
	include "clear2.asm"
clear2_data_end

	include "!player.asm"
	include "!player_data.asm"
	include "music.asm"	
;eof