vibrato
	db $00,$01,$02,$01 
	db $00,$81,$82,$81
	
snare_freq
	db $B5,$A4,$73

bass_freq
	dw $15E,$A9,$40

	align 256
vol_default
	db 8,7,6,5,4,3,3,3,3
	db 4,4,3,3,2,2,1,1,1
	db $FF
	
vol_arp
	db 8,7,4,4,4,3,3,3,2
	db 8,7,4,4,4,3,3,3,2
	;
	db 8,7,4,4,4,4,4,4,4
	db 4,4,4,3,3,3,3,2,2
	;
	db 8,7,4,4,4,4,4,4,4
	db 4,4,4,3,3,3,3,2,2
	db $FF
	
vol_echo
	db 8,7,6,5,4,4,3,2,2
	db $FF
	
Channel1
	dw pat_bass1
	dw pat_bass2
	dw pat_bass1
	;
	dw pat_bass1
	;
	dw pat_bass1
	dw pat_bass2
	dw pat_bass1
	;
	dw pat_bass1
	dw pat_bass1
	dw pat_bass2
	dw pat_bass1
	;
	dw 0
	
Channel2
	dw pat_lead1
	dw pat_lead2
	dw pat_lead3
	;
	dw pat_mid
	;
	dw pat_lead1_hi
	dw pat_lead2_hi
	dw pat_lead1_hi
	;
	dw pat_quiet
	;
	dw pat_lead1
	dw pat_lead2
	dw pat_lead3
	;
	dw 0

Channel3
	dw pat_quiet
	dw pat_quiet
	dw pat_quiet
	;
	dw pat_quiet
	;
	dw pat_quiet
	dw pat_quiet
	dw pat_quiet
	;
	dw pat_arp
	dw pat_arp
	dw pat_arp2
	dw pat_arp_hi
	;
	dw 0
	
	
LEN = $50

speed = 9

bdr = $F1
snr = $F2
sn = 28

pat_quiet
	db $F0
	db LEN+speed*6
	db OFF,OFF,OFF,OFF
	db OFF,OFF,OFF,OFF
	db END_MARK
	
pat_bass1
	db $F0,LEN+speed*2
	db OFF
	db G0,OFF,OFF
	db C0,OFF,C0
	db A0,OFF,OFF ; A7
	db D0,OFF,D0
	db B0,OFF,OFF ; B7
	db E0,OFF,D0  ; Em
	db C0,OFF,D0  ; Am,D7
	db G0,OFF
	db END_MARK
	
pat_bass2
	db $F0,LEN+speed*2
	db OFF
	db G0,OFF,OFF
	db D0,OFF,OFF
	db A0,OFF,OFF
	db D0,OFF,OFF
	db G0,OFF,OFF
	db D0,OFF,OFF
	db C0,OFF,D0
	db G0,OFF
	db END_MARK
	
pat_lead1
	db SET_VOLTAB,vol_default & 255
	db $F5
	db LEN+speed*2, D1,G1
	db LEN+4,G1, LEN+speed-4,OFF
	db LEN+4,A1, LEN+speed-4,OFF
	db LEN+4,G1, LEN+speed-4,OFF
	db LEN+4,Fi1,LEN+speed-4,OFF
	db LEN+speed*2, E1,E1
	db              E1,A1
	db LEN+4,A1, LEN+speed-4,OFF
	db LEN+4,B1, LEN+speed-4,OFF
	db LEN+4,A1, LEN+speed-4,OFF
	db LEN+4,G1, LEN+speed-4,OFF
	db LEN+speed*2, Fi1,D1
	db              D1,B1
	db LEN+4,B1, LEN+speed-4,OFF
	db LEN+4,C2, LEN+speed-4,OFF
	db LEN+4,B1, LEN+speed-4,OFF
	db LEN+4,A1, LEN+speed-4,OFF
	db LEN+speed*2, G1,E1
	db LEN+speed-1,D1,LEN+1,OFF
	db LEN+speed,D1
	db LEN+speed*2, E1,A1,Fi1,G1,OFF
	db END_MARK
	
pat_lead2
	db SET_VOLTAB,vol_default & 255
	db $F5
	db LEN+speed*2, D1,G1
	db G1,G1,Fi1,OFF
	db Fi1,G1,Fi1,E1,D1,OFF
	db A1,B1,A1,G1,D2,D1
	db D1,E1,A1,Fi1,G1,OFF
	db END_MARK
	
pat_lead3
	db SET_VOLTAB,vol_default & 255
	db $F5
	db LEN+speed*2, D1,G1
	db LEN+4,G1, LEN+speed-4,OFF
	db LEN+4,A1, LEN+speed-4,OFF
	db LEN+4,G1, LEN+speed-4,OFF
	db LEN+4,Fi1,LEN+speed-4,OFF
	db LEN+speed*2, E1,E1
	db              E1,A1
	db LEN+4,A1, LEN+speed-4,OFF
	db LEN+4,B1, LEN+speed-4,OFF
	db LEN+4,A1, LEN+speed-4,OFF
	db LEN+4,G1, LEN+speed-4,OFF
	db LEN+speed*2, Fi1,D1
	db              D1,B1
	db LEN+4,B1, LEN+speed-4,OFF
	db LEN+4,C2, LEN+speed-4,OFF
	db LEN+4,B1, LEN+speed-4,OFF
	db LEN+4,A1, LEN+speed-4,OFF
	db LEN+speed*2, G1,E1,D1
	db LEN+speed*2, E1,A1,Fi1,G1,OFF
	db END_MARK
	
pat_lead1_hi
	db SET_VOLTAB,vol_default & 255
	db $F5
	db LEN+speed*2, D2,G2
	db LEN+4,G2, LEN+speed-4,OFF
	db LEN+4,A2, LEN+speed-4,OFF
	db LEN+4,G2, LEN+speed-4,OFF
	db LEN+4,Fi2,LEN+speed-4,OFF
	db LEN+speed*2, E2,E2
	db              E2,A2
	db LEN+4,A2, LEN+speed-4,OFF
	db LEN+4,B2, LEN+speed-4,OFF
	db LEN+4,A2, LEN+speed-4,OFF
	db LEN+4,G2, LEN+speed-4,OFF
	db LEN+speed*2, Fi2,D2
	db              D2,B2
	db LEN+4,B2, LEN+speed-4,OFF
	db LEN+4,C3, LEN+speed-4,OFF
	db LEN+4,B2, LEN+speed-4,OFF
	db LEN+4,A2, LEN+speed-4,OFF
	db LEN+speed*2, G2,E2
	db LEN+speed-1,D2,LEN+1,OFF
	db LEN+speed,D2
	db LEN+speed*2, E2,A2,Fi2,G2,OFF
	db END_MARK
	
pat_lead2_hi
	db SET_VOLTAB,vol_default & 255
	db $F5
	db LEN+speed*2, D2,G2
	db G2,G2,Fi2,OFF
	db Fi2,G2,Fi2,E2,D2,OFF
	db A2,B2,A2,G2,D3,D2
	db D2,E2,A2,Fi2,G2,OFF
	db END_MARK
	
pat_mid_2
	db SET_ARP,$0C
	db $F4,LEN+speed
	db OFF,OFF
	db G1, B1, D2, G2, D2, B1
	db G1, C2, E2, G2, E2, C2
	db A1, C2, E2, G2, E2, C2
	db A1, D2, Fi2,A2, Fi2,D2
	db B1, D2, Fi2,A2, Fi2,D2
	db B1, E2, G2, B2, G2, E2
	db G1, B1, C2, D2, E2, Fi2
	db G2
	db OFF,OFF,OFF
	db END_MARK
	
pat_mid
	db SET_VOLTAB,vol_echo & 255
	db SET_ARP,$0C
	db $F4,LEN+speed
	db OFF,OFF
	db LEN+5,G1, LEN+4,OFF,LEN+5,B1, LEN+4,G1, LEN+5,D2, LEN+4,B1, LEN+5,G2, LEN+4,D2, LEN+5,D2, LEN+4,G2, LEN+5,B1, LEN+4,D2
	db LEN+5,G1, LEN+4,B1, LEN+5,C2, LEN+4,G1, LEN+5,E2, LEN+4,C2, LEN+5,G2, LEN+4,E2, LEN+5,E2, LEN+4,G2, LEN+5,C2, LEN+4,E2
	db LEN+5,A1, LEN+4,C2, LEN+5,C2, LEN+4,A1, LEN+5,E2, LEN+4,C2, LEN+5,G2, LEN+4,E2, LEN+5,E2, LEN+4,G2, LEN+5,C2, LEN+4,E2
	db LEN+5,A1, LEN+4,C2, LEN+5,D2, LEN+4,A1, LEN+5,Fi2,LEN+4,D2, LEN+5,A2, LEN+4,Fi2,LEN+5,Fi2,LEN+4,A2, LEN+5,D2, LEN+4,Fi2
	db LEN+5,B1, LEN+4,D2, LEN+5,D2, LEN+4,B1, LEN+5,Fi2,LEN+4,D2, LEN+5,A2, LEN+4,Fi2,LEN+5,Fi2,LEN+4,A2, LEN+5,D2, LEN+4,Fi2
	db LEN+5,B1, LEN+4,D2, LEN+5,E2, LEN+4,B1, LEN+5,G2, LEN+4,E2, LEN+5,B2, LEN+4,G2, LEN+5,G2, LEN+4,B2, LEN+5,E2, LEN+4,G2
	db LEN+5,G1, LEN+4,E2, LEN+5,B1, LEN+4,G1, LEN+5,C2, LEN+4,B1, LEN+5,D2, LEN+4,C2, LEN+5,E2, LEN+4,D2, LEN+5,Fi2,LEN+4,E2
	db LEN+5,G2, LEN+4,Fi2,LEN+5,OFF,LEN+4,G2
	db LEN+speed
	db OFF,OFF
	db END_MARK
	
pat_arp
	db SET_VOLTAB,vol_arp & 255
	db $F3
	db LEN+speed
	db OFF,OFF
	db G2, B2, D3, OFF,D3, OFF
	db G2, C3, E3, OFF,OFF,OFF
	db A2, C3, E3, OFF,E3, OFF
	db A2, D3, Fi3,OFF,OFF,OFF
	db B2, D3, Fi3,OFF,Fi3,OFF
	db B2, E3, G3, OFF,OFF,OFF
	db G3, Fi3,E3, OFF,D3, OFF
	db B2, A2, G2, OFF
	db END_MARK
	
pat_arp2
	db SET_VOLTAB,vol_arp & 255
	db $F3
	db LEN+speed
	db OFF,OFF
	db G2, B2, D3, OFF,D3, OFF
	db Fi3,D3, A2, OFF,OFF,OFF
	db E2, G2, B2, OFF,B2, OFF
	db D3, A2, Fi2,OFF,OFF,OFF
	db D2, G2, B2, OFF,B2, OFF
	db A2, Fi2,D2, OFF,OFF,OFF
	db C2, E2, G2, OFF,A2, OFF
	db B2, A2, G2, OFF
	db END_MARK
	
pat_arp_hi
	db $F3
	db LEN+speed
	db OFF,OFF
	db G3, B3, D4, OFF,D4, OFF
	db G3, C4, E4, OFF,OFF,OFF
	db A3, C4, E4, OFF,E4, OFF
	db A3, D4, Fi4,OFF,OFF,OFF
	db B3, D4, Fi4,OFF,Fi4,OFF
	db B3, E4, G4, OFF,OFF,OFF
	db G4, Fi4,E4, OFF,D4, OFF
	db B3, A3, G3, OFF
	db END_MARK
;[eof]